/* $Id: dolhn.c,v 5.27 2013/09/26 09:43:32 sasa Exp $ */
/*24.05.2016    06.01.1993      Белых А.И.      dolhn.c
Автоматизированное начисление за должность с учетом
отработанного времени
Если в конце стоит буква Ч значит это не оклад а
почасовая ставка
Возвращяем коэффициент полноты выплаты
*/
#include        <ctype.h>
#include        <errno.h>
#include        "buhg.h"

extern double   okrg;
extern float    hasov; /*Количество рабочих часов в текущем месяце*/

double dolhn(int tn, //Табельный номер
short mp,short gp, //Дата
int kp,  //Код подразделения
const char *nah_only)
{
double		koefpv;
short           d;
int             kodokl; /*Код должносного оклада*/
double          oklad;  /*Оклад*/
double          nah;
int             met; /*0-оклад 1-часовая ставка 2-не пересчитываемый оклад*/
SQL_str         row;
SQLCURSOR curr;
char		strsql[1024];
float		dneii,has;
float		kolrd=0.; /*Количество рабочих дней в месяце*/
class iceb_tu_str shet("");
float		has1;   /*Количество часов в одном рабочем дне*/
float		kof;   /*Коэффициент оплаты ставки*/
float		mesnoh;  /*Месячная норма отработанных часов*/
double		procent=0.,procb=0.;
int		metka; /*0-нет метки 1-есть Метка пересчета на процент выполнения плана подразделением*/
int		metka1; /*0-расчёт выполнять по отработанным часам 1-дням*/
int		nomz=0;
int metka_no;
class ZARP     zp;
int		kodtab=0;
float dnei=0.,hasov=0.;

koefpv=oklad=nah=0.;

redkal(mp,gp,&dnei,&hasov);

/*
printw("dolhn-%d %d.%d %d\n",tn,mp,gp,kp);
refresh();
*/
sprintf(strsql,"\n%s-Расчёт должностных окладов\n---------------------------\n",__FUNCTION__);
zar_pr_ins(strsql);


kolrd=dnei;
met=0;

sprintf(strsql,"%s-Просматриваем файл должностных окладов\n",__FUNCTION__);
zar_pr_ins(strsql);

if(dolhn1(tn,&oklad,&has1,&kof,&met,&kodokl,&metka,&metka1,&shet,&metka_no,mp,gp) != 0)
  return(koefpv);

if(proverka(nah_only,kodokl,0,0) != 0)
 {
  sprintf(strsql,"%s-Код должностного оклада исключён из расчёта %d\n",__FUNCTION__,kodokl);
  zar_pr_ins(strsql);
  return(koefpv);
  
 }

if(shet.ravno()[0] == '*')
 {
  //читаем счёт в карточке
  sprintf(strsql,"select shet from Kartb where tabn=%d",tn);
  if(readkey(strsql,&row,&curr) == 1)
   shet.new_plus(row[0]);
  else
   shet.new_plus("");
 }
if(shet.ravno()[0] != '\0')
 {
  OPSHET opshet;
  if(prsh1(shet.ravno(),&opshet) != 0)
    shet.new_plus("");
 }

sprintf(strsql,"\n%s-Табельный номер:%d dolhn-dnei=%.2f hasov=%.2f oklad=%.2f has1=%.2f kof=%.2f met=%d kodok=%d\n",
__FUNCTION__,
tn,dnei,hasov,oklad,has1,kof,met,kodokl);
zar_pr_ins(strsql);
  

if(met == 2)
  oklad=okladtr(mp,gp,(int)oklad); /*oklad содержит тарифный разряд*/

if(kodokl == 0)
 {
  sprintf(strsql,"%s-%s\n",__FUNCTION__,"Не введён код оклада !!!");
  zar_pr_ins(strsql);
  return(koefpv);
 }



/*Проверяем есть ли код начисления в списке*/

sprintf(strsql,"select shet from Zarn1 where tabn=%d and prn='1' and knah=%d",tn,kodokl); 
if(sql_readkey(&bd,strsql,&row,&curr) != 1)
 {
  sprintf(strsql,"%s-Не нашли код %d в списке начислений для %d табельного номера !\n",__FUNCTION__,kodokl,tn);
  zar_pr_ins(strsql);
  return(koefpv);
 }
if(shet.ravno()[0] == '\0')
  shet.new_plus(row[0]);

/*Читаем код табеля*/
sprintf(strsql,"select kodt from Nash where kod=%d",kodokl);
if(sql_readkey(&bd,strsql,&row,&curr) != 1)
 {
  sprintf(strsql,"%s-Нет кода начисления %d в списке начислений !\n",__FUNCTION__,kodokl);
  zar_pr_ins(strsql);
  return(koefpv);
 }
kodtab=atoi(row[0]);

sprintf(strsql,"%s-Код табеля для автоматизированного расчёта %d\n",__FUNCTION__,kodtab);
zar_pr_ins(strsql);

/*Читаем табель*/
/*****************
if(kom[0] != '\0')
 sprintf(strsql,"select dnei,has,kolrd,kolrh,nomz from Ztab \
where god=%d and mes=%d and tabn=%d and kodt=%d and kom='%s' \
order by nomz asc",gp,mp,tn,kodtab,kom);
else
********************/
 sprintf(strsql,"select dnei,has,kolrd,kolrh,nomz from Ztab \
where god=%d and mes=%d and tabn=%d and kodt=%d order by nomz asc",
 gp,mp,tn,kodtab);

if(sql_readkey(&bd,strsql,&row,&curr) == 0)
 {
  dneii=has=0.;
  kolrd=0.;
  nomz=0;
  sprintf(strsql,"%s-%s\nНе найден код табеля %d указанного в начислении.\n",__FUNCTION__,strsql,kodtab);
  zar_pr_ins(strsql); }
else
 {
  nomz=atoi(row[4]);
  dneii=atof(row[0]);
  has=atof(row[1]);
  if(atof(row[2]) != 0.)
   {
    kolrd=atof(row[2]);
    sprintf(strsql,"%s-Количество рабочих дней в месяце взяли из табеля=%.2f\n",__FUNCTION__,kolrd);
    zar_pr_ins(strsql);   
   }
  if(atof(row[3]) != 0.)
   {
    has1=atof(row[3]);
    sprintf(strsql,"%s-Количество рабочих часов в месяце взяли из табеля=%.2f\n",__FUNCTION__,has1);
    zar_pr_ins(strsql);
   }
 }

mesnoh=hasov;
if(has1 != 0.)
 {
  mesnoh=kolrd*has1;
  sprintf(strsql,"%s-mesnoh=%.2f*%.2f=%.2f\n",__FUNCTION__,kolrd,has1,mesnoh);
  zar_pr_ins(strsql);
 }  
else
 {
  sprintf(strsql,"%s-mesnoh=%.2f\n",__FUNCTION__,mesnoh);
  zar_pr_ins(strsql);
 }

nah=0.;
if(metka_no == 1) /*не пересчитываемый оклад*/
 {
  nah=oklad;
  koefpv=1.;
 }
else
 {
  if(met == 0 || met == 2) /*расчёт по окладу*/
   {
    if(mesnoh > 0.00001 && metka1 == 0)
     {
      nah=oklad/mesnoh*has;
      koefpv=has/mesnoh;
      sprintf(strsql,"%s-Расчёт по месячному окладу.Начислено(по часам)=%.2f/%.2f*%.2f=%.2f koefpv=%.2f/%.2f=%f\n",
      __FUNCTION__,oklad,mesnoh,has,nah,has,mesnoh,koefpv);
      zar_pr_ins(strsql);
     }
    if(metka1 == 1 && kolrd > 0)
     {
      nah=oklad/kolrd*dneii;
      koefpv=dneii/kolrd;
      sprintf(strsql,"%s-Расчёт по месячному окладу.Начислено(по дням)=%.2f/%.2f*%.2f=%.2f koefpv=%f\n",__FUNCTION__,oklad,kolrd,dneii,nah,koefpv);
      zar_pr_ins(strsql);
     }   
   }
 }

if(met == 1) /*расчёт по часовой ставке*/
 {
  nah=oklad*has;
  koefpv=1.;
  sprintf(strsql,"%s-Расчёт по часовой ставке. Начислено=%.2f*%.2f=%.2f koefpv=%f\n",__FUNCTION__,oklad,has,nah,koefpv);
  zar_pr_ins(strsql);
 }

if(met == 3) /*расчёт по дневной ставке*/
 {
  nah=oklad*kolrd;
  koefpv=1.;
  sprintf(strsql,"%s-Расчёт по дневной ставке. Начислено=%.2f*%.2f=%.2f koefpv=%f\n",__FUNCTION__,oklad,kolrd,nah,koefpv);
  zar_pr_ins(strsql);
 }
 
if(metka == 1)
 {
  
  procent=zarpodpr(kp,&procb);

  sprintf(strsql,"%s-Учет процента выполнения плана подразделением %d, процент: %.2f %%\n",__FUNCTION__,kp,procent);   
  zar_pr_ins(strsql);

  sprintf(strsql,"%s-%.2f*%.2f/100=",__FUNCTION__,nah,procent);
  zar_pr_ins(strsql);

  koefpv*=procent/100.;
  nah=nah*procent/100.;
  sprintf(strsql,"%s-%.2f koefpv=%f\n",__FUNCTION__,nah,koefpv);
  zar_pr_ins(strsql);

 } 

if(nah > 0.)
  nah=okrug(nah,okrg);
/*
if(ff_prot != NULL)
  fprintf(ff_prot,"%s: %.2f (%s:%.2f/%.2f %s:%.2f %s:%.2f)\n\n",
gettext("Начислено"),
nah,
gettext("Часов"),
mesnoh,has,
gettext("Дней"),dneii,
gettext("Оклад"),oklad);
*/
dpm(&d,&mp,&gp,5);

zp.dz=d;
zp.mesn=mp; zp.godn=gp;
zp.nomz=0;
zp.podr=kp;
strcpy(zp.shet,shet.ravno());

zapzarp(d,mp,gp,tn,1,kodokl,nah,shet.ravno(),mp,gp,0,nomz,"",kp,"",zp); 

return(koefpv);
}
