/* $Id: find_podoh.c,v 5.16 2013/09/26 09:43:32 sasa Exp $ */
/*21.08.2012    04.02.2004      Белых А.И.      find_podoh.c
Поиск всех начислений на нужного человека за указанный
месяц и год
*/
#include        <math.h>
#include        "buhg.h"
//#include        "zar11.h"

int find_podoh_prov(short mr,int prnu,short mes,int knu,double suma,double *suma_ndfv_bnds_b,double *sumabu,double *sumanb,double *nah,char *sheta);


extern short    *knvr;/*Коды начислений не входящие в расчёт налогов*/
extern short    *kuvr;/*Коды удержаний входящие в расчёт налогов*/
extern float pnds;
extern char	*shetb; /*Бюджетные счета*/
extern  short   *kodbl; /*Код больничного*/
extern short *knnf; /*Коды начислений неденежными формами*/

/****************/
/*Чтение в базе*/
/****************/

double find_podoh(short mr,short gr, //Дата расчёта
int tabn,
double *suma_ndfv, //Сумма не денежных форм выплат c начисленым НДС если это нужно на которые распространяется социальная льгота
double *sumanb, //Сумма не бюджетная
double *sumabu) //Сумма бюджетная
{
char strsql[1024];
SQL_str row;
SQLCURSOR cur;
int kolstr;
double nah;

sprintf(strsql,"%s-Поиск начислений\n",__FUNCTION__);
zar_pr_ins(strsql);

sprintf(strsql,"%s-Коды неденежных форм выплаты-",__FUNCTION__);
zar_pr_ins(strsql);

if(knnf != NULL)
for(int nomer=1; nomer <= knnf[0]; nomer++)
 {
  sprintf(strsql,"%d,",knnf[nomer]);
  zar_pr_ins(strsql);
 }
sprintf(strsql,"\n");
zar_pr_ins(strsql);

*suma_ndfv=*sumanb=*sumabu=nah=0.;

sprintf(strsql,"select prn,knah,suma,shet,mesn from Zarp where datz >= '%04d-%02d-%02d' \
and datz <= '%04d-%02d-%02d' and tabn=%d and suma <> 0.",gr,mr,1,gr,mr,31,tabn);
if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(0.);
 }
while(cur.read_cursor(&row) != 0)
 {
//  sprintf(strsql,"%s-%s %s %s\n",__FUNCTION__,row[0],row[1],row[2]);
//  zar_pr_ins(strsql);

  if(find_podoh_prov(mr,atoi(row[0]),atoi(row[4]),atoi(row[1]),atof(row[2]),
  suma_ndfv,sumabu,sumanb,&nah,row[3]) != 0)
    break;

 }

return(nah);


}



/********************************/
/*Проверка */
/**********************************/

int find_podoh_prov(short mr,int prnu,short mes,int knu,double suma,
double *suma_ndfv,double *sumabu,double *sumanb,double *nah,char *sheta)
{
if(prnu == 0)
 return(1);

char strsql[1024];
if(prnu == 1)
 {
  sprintf(strsql,"%s-suma=%.2f\n",__FUNCTION__,suma);
  zar_pr_ins(strsql);
  

  /*Если больничный не за текущий месяц то в общюю сумму не включ.*/
  /*Для расчёта профсоюзного взносов включается*/
  /*Для этих удержаний делается перерасчёт по этим больничным отдельно*/
  
  if(mes != mr)
    if( provkod(kodbl,knu) >= 0)
     {
      sprintf(strsql,"Не вошло в расчёт %d %.2f\n",knu,suma);
      zar_pr_ins(strsql);
      return(0);
     }

  /*Коды начислений не входящие в расчёт подоходного налога*/
  if(provkod(knvr,knu) >= 0)
   {
    sprintf(strsql,"%s-Не вошло в расчёт %d %.2f\n",__FUNCTION__,knu,suma);
    zar_pr_ins(strsql);
    return(0);
   }
  double budget=0.;

  *suma_ndfv+=knnfnds(0,knu,"",suma,&budget,0);


  if(shetb != NULL ) 
   {
    /*Узнаем какая часть суммы бюджетных счетов и всех остальных*/
    if(proverka(shetb,sheta,0,1) == 0)
        *sumabu+=suma;
    else
        *sumanb+=suma;
   }

  *nah+=suma;
 
 }

if(prnu == 2)
 {
  /*Коды удержаний входящие в расчёт подоходного налога*/

  if(provkod(kuvr,knu) >= 0)
   {
    *nah+=suma; //Удержание отрицательное поэтому для того, чтобы уменьшить сумму мы его просто прибавляем
    sprintf(strsql,"%s-Вошло в расчёт удержание %d %.2f\n",__FUNCTION__,knu,suma);
    zar_pr_ins(strsql);
    return(0);
   }

 }
return(0);

}
