/*$Id: podohrs2.c,v 5.16 2014/02/28 05:13:47 sasa Exp $*/
/*11.01.2016	15.12.2003	Белых А.И.	podohrs2.c
Расчёт подоходного налога в соответствии с новым законом вступающим в силу с 1.1.2004г.
Возвращяем величину подоходного налога
После 1.1.2011
*/
#include <math.h>
#include        "buhg.h"

double podohrs2_pr1(short mes,short god,int tabnom,float proc1,float proc2,double suma_zar,double suma_esv,double suma_bsl,double minzar_ng,float max_sum_for_soc,double suma_ndfv,int metka_p_boln);


extern double   okrg;
extern float  kof_prog_min; //Коэффициент прожиточного минимума
extern float  ppn; //Процент подоходного налога
extern float  pomzp; //Процент от минимальной заработной платы

double lgota=0.;

double podohrs2(int tabn,
short mr,short gr,
double suma_zar, //Сумма зарплаты на которую распространяется соц-льгота
double suma_soc_ot, //сумма соц-отчислений c зарплаты
double suma_bsl, //Сумма на которую не распространяестя социальная льгота
double suma_ndfv, //Сумма неденежных форм выплаты на которую распространяется соц. льгота
int metka_zap, /*0-делать запись 1-нет*/
int metka_zap_lgot, /*0-устанавливать/снимать льготу 1-нет*/
int metka_p_boln) /*0-обычный расчёт 1-перерасчёт вместе с больничным будущих периодов*/
{
char strsql[1024];
char stroka[1024];
float procent=0.;
float pr_b10mz=17.; /* Процент который берётся если сумма больше 10 минимальных зарплат*/
if(sravmydat(1,mr,gr,1,1,2015) >= 0)
 pr_b10mz=20.;
double nalog=0.;
double  maxsum=0.;
double suma_bso=0.;
short du=0,mu=0,gu=0;
class zar_read_tn1h nast_mz;
SQLCURSOR cur;
SQL_str   row;
lgota=0.;

//читаем дату увольнения
sprintf(stroka,"select datk from Zarn where tabn=%d and god=%d and mes=%d",tabn,gr,mr);
if(sql_readkey(&bd,stroka,&row,&cur) == 1)
 rsdat(&du,&mu,&gu,row[0],2);

zar_read_tn1(1,mr,gr,&nast_mz);
  
maxsum=nast_mz.prog_min_ng*kof_prog_min;


sprintf(strsql,"\n%s\nМинимальная зарплата на начало года=%.2f\n",__FUNCTION__,nast_mz.minzar_ng);
zar_pr_ins(strsql);
sprintf(strsql,"Прожиточный минимум на начало года=%.2f\n",nast_mz.prog_min_ng);
zar_pr_ins(strsql);
sprintf(strsql,"Коэффициент прожиточного минимума=%.2f\n",kof_prog_min);
zar_pr_ins(strsql);
sprintf(strsql,"Процент подоходного налога=%.2f\n",ppn);
zar_pr_ins(strsql);
sprintf(strsql,"Процент от минимальной зарплаты=%.2f\n",pomzp);
zar_pr_ins(strsql);
sprintf(strsql,"Сумма на которую не распростаняется социальная льгота=%.2f\n",suma_bsl);
zar_pr_ins(strsql);
sprintf(strsql,"Сумма на которую распростаняется социальная льгота=%.2f\n",suma_zar);
zar_pr_ins(strsql);
sprintf(strsql,"Сумма социальных отчислений=%.2f\n",suma_soc_ot);
zar_pr_ins(strsql);
sprintf(strsql,"Сумма неденежных форм выплаты на которую распространяестя социальная льгота=%.2f\n",suma_ndfv);
zar_pr_ins(strsql);
sprintf(strsql,"Дата расчёта зарплаты %d.%d\n",mr,gr);
zar_pr_ins(strsql);
sprintf(strsql,"Дата увольнения %d.%d.%d\n",du,mu,gu);
zar_pr_ins(strsql);
sprintf(strsql,"Максимальный доход для льгот:%.2f*%.2f = %.2f\n",nast_mz.prog_min_ng,kof_prog_min,maxsum);
zar_pr_ins(strsql);

maxsum=okrug(maxsum,10.);

sprintf(strsql,"%s-Округлили %.2f\n",__FUNCTION__,maxsum);
zar_pr_ins(strsql);


sprintf(strsql,"%s-Сумма без соц-отчислений=%.2f %.2f=%.2f\n",__FUNCTION__,suma_zar,suma_soc_ot,suma_zar+suma_soc_ot);
zar_pr_ins(strsql);

if(suma_zar > 0.)  //Отрицательные поэтому прибавляем
  suma_bso=suma_zar+suma_soc_ot;

int kollgot=0;
class iceb_tu_str kod_lgot("");
procent=zarlgot(tabn,mr,gr,&kollgot,&kod_lgot);


sprintf(strsql,"%s-Количество социальных льгот=%d\n",__FUNCTION__,kollgot);
zar_pr_ins(strsql);

sprintf(strsql,"%s-Максимальная сумма для которой применяется льгота %.2f*%d=%.2f\n",
__FUNCTION__,maxsum,kollgot,maxsum*kollgot);
zar_pr_ins(strsql);

maxsum*=kollgot;

if(maxsum < suma_zar)
 {
  /*Льгота не применялась*/
  if(metka_zap == 0 && metka_zap_lgot == 0)
   {
    sprintf(stroka,"update Zarn set lgot='' where tabn=%d and god=%d and mes=%d",tabn,gr,mr);
    sql_zapis(stroka,1,0);
   }

  sprintf(strsql,"%s-*Льготы по подоходному налогу не применяються %.2f < %.2f\n%s\n",__FUNCTION__,maxsum,suma_zar,stroka);
  zar_pr_ins(strsql);
  
  nalog=podohrs2_pr1(mr,gr,tabn,ppn,pr_b10mz,suma_zar,suma_soc_ot,suma_bsl,nast_mz.minzar_ng,nast_mz.max_sum_for_soc,suma_ndfv,metka_p_boln);

  
  nalog=okrug(nalog,okrg);
  return(nalog);
 }




if(procent == 0.)
 {
  lgota=0.;
  /*Льгота не применялась*/
  if(metka_zap == 0 && metka_zap_lgot == 0)
   {
    sprintf(stroka,"update Zarn set lgot='' where tabn=%d and god=%d and mes=%d",tabn,gr,mr);
    sql_zapis(stroka,1,0);
   }
  sprintf(strsql,"%s-Не имеет льгот!\n%s\n",__FUNCTION__,stroka);
  zar_pr_ins(strsql);

  
  nalog=podohrs2_pr1(mr,gr,tabn,ppn,pr_b10mz,suma_zar,suma_soc_ot,suma_bsl,nast_mz.minzar_ng,nast_mz.max_sum_for_soc,suma_ndfv,metka_p_boln);


  nalog=okrug(nalog,okrg);

  return(nalog);
 }
else
 {

  lgota=nast_mz.minzar_ng*(procent/100)*(pomzp/100);
  
  sprintf(strsql,"%s-Расчётная сумма льготы=%.2f*%.2f/100*%.2f/100=%.2f\n",__FUNCTION__,nast_mz.minzar_ng,procent,pomzp,lgota);
  zar_pr_ins(strsql);
 }


if(suma_zar+suma_bsl <= maxsum)
 {
  /*Льгота применялась*/
  if(kod_lgot.getdlinna() <= 1)
   kod_lgot.new_plus("01");
  if(metka_zap == 0 && metka_zap_lgot == 0)
   {
    sprintf(stroka,"update Zarn set lgot='%s' where tabn=%d and god=%d and mes=%d",kod_lgot.ravno(),tabn,gr,mr);
    sql_zapis(stroka,1,0);
   }
  sprintf(strsql,"%s-Льгота применяется так как %.2f+%.2f <= %.2f\n%s\n",__FUNCTION__,suma_zar,suma_bsl,maxsum,stroka);
  zar_pr_ins(strsql);


  if(suma_bso < lgota) /*Если отнять будет отрицательное число*/
   {
    sprintf(strsql,"%s-Cумма начисления %.2f меньше льготы %.2f\n",__FUNCTION__,suma_bso,lgota);
    zar_pr_ins(strsql);

    if(suma_bsl != 0.)
     {
      nalog=podohrs2_pr1(mr,gr,tabn,ppn,pr_b10mz,0.,0.,suma_bsl,nast_mz.minzar_ng,nast_mz.max_sum_for_soc,suma_ndfv,metka_p_boln);
     }
    else
     {
      sprintf(strsql,"%s-Налог не берётся!\n",__FUNCTION__);
      zar_pr_ins(strsql);
      return(0.);
     }

   }
  else
   {

    sprintf(strsql,"%s-Cумма начисления %.2f больше льготы %.2f suma_bsl=%f\n",__FUNCTION__,suma_bso,lgota,suma_bsl);
    zar_pr_ins(strsql);
    nalog=podohrs2_pr1(mr,gr,tabn,ppn,pr_b10mz,suma_zar-lgota,suma_soc_ot,suma_bsl,nast_mz.minzar_ng,nast_mz.max_sum_for_soc,suma_ndfv,metka_p_boln);
   }

  nalog=okrug(nalog,okrg);

  
 }
else
 {
  /*Льгота не применялась*/
  if(metka_zap == 0 && metka_zap_lgot == 0)
   {
    sprintf(stroka,"update Zarn set lgot='' where tabn=%d and god=%d and mes=%d",tabn,gr,mr);
    sql_zapis(stroka,1,0);
   }
  sprintf(strsql,"%s-Льгота не применяется так как %.2f+%.2f > %.2f\n%s\n",__FUNCTION__,suma_zar,suma_bsl,maxsum,stroka);
  zar_pr_ins(strsql);


  nalog=podohrs2_pr1(mr,gr,tabn,ppn,pr_b10mz,suma_zar,suma_soc_ot,suma_bsl,nast_mz.minzar_ng,nast_mz.max_sum_for_soc,suma_ndfv,metka_p_boln);

 }

return(nalog);

}
/***********************************/
/**********************************************************/

double podohrs2_pr1(short mes,short god,
int tabnom,
float proc1,
float proc2,
double suma_zar, /*Cумма на которую распространяется соц. льгота*/
double suma_esv, /*пересчитанная с учётом больничных будущих периодов*/
double suma_bsl,
double minzar_ng,
float max_sum_for_soc,
double suma_ndfv, /*Cумма не денежных форм выплаты находящаяся в общей сумме зарплаты*/
int metka_p_boln) /*метка перерасчёта с учётом больничных будущих периодов*/
{
char strsql[2048];
double minzar10=minzar_ng*10.;
double suma_nal=0.;

class zar_sumtn tnsum; 
zar_sumtn(mes,god,tabnom,0,&tnsum); /*читаем всё что нужно для расчёта*/

sprintf(strsql,"%s-Рассчитываем налог\n",__FUNCTION__);
zar_pr_ins(strsql);

if(metka_p_boln == 1)
if(tnsum.suma_boln_bp != 0.)
 {
  sprintf(strsql,"%s-Увеличиваем сумму на сумму больничных будущих периодов %.2f+%.2f=%.2f\n",
  __FUNCTION__,
  tnsum.suma_nah_all_podoh,tnsum.suma_boln_bp,tnsum.suma_nah_all_podoh+tnsum.suma_boln_bp);
  tnsum.suma_nah_all_podoh+=tnsum.suma_boln_bp;
  zar_pr_ins(strsql);
 }

sprintf(strsql,"%s-Десять минимальных зарплат %.2f*10=%.2f\n",__FUNCTION__,minzar_ng,minzar10);
zar_pr_ins(strsql);

double suma_for_srav=tnsum.suma_nah_all_podoh+suma_esv;

sprintf(strsql,"%s-Сумма для сравнения %.2f+%.2f=%.2f\n",
__FUNCTION__,tnsum.suma_nah_all_podoh,suma_esv,suma_for_srav);

zar_pr_ins(strsql);

if(suma_for_srav <= minzar10)
 {
  if(suma_ndfv != 0.)
    rudnfv(&suma_zar,suma_ndfv,proc1);

  suma_nal=(suma_zar+suma_esv)*proc1/100.+suma_bsl*proc1/100.;
  sprintf(strsql,"%s-Cумма %.2f меньше десяти минимальных зарплат %.2f\n",__FUNCTION__,suma_for_srav,minzar10);
  zar_pr_ins(strsql);
  sprintf(strsql,"%s-Подоходный налог:(%.2f+%.2f)*%.2f/100.+%.2f*%.2f/100.=%.2f\n",
  __FUNCTION__,suma_zar,suma_esv,proc1,suma_bsl,proc1,suma_nal);
  zar_pr_ins(strsql);
 }
else
 {
/*Перед расчётом отнимает единый социальный взнос и с остатка берём подоходный*/
  sprintf(strsql,"%s-Cумма %.2f больше десяти минимальных зарплат %.2f\n",__FUNCTION__,suma_for_srav,minzar10);
  zar_pr_ins(strsql);



  suma_ndfv=tnsum.suma_ndfv_slg+tnsum.suma_ndfv_blg;
  double suma15_ndfv=0.;
  double suma17_ndfv=0.;
  if(suma_ndfv != 0.)
   {
    sprintf(strsql,"%s-Cумма неденежных форм выплаты %.2f\n",__FUNCTION__,suma_ndfv);
    zar_pr_ins(strsql);
    if(tnsum.suma_nah_all_podoh-suma_ndfv < minzar10)
     {
      
      sprintf(strsql,"%s-Cумма зарплаты %.2f без неденежных форм выплаты %.2f меньше 10 минимальных зарплат %.2f\n",__FUNCTION__,tnsum.suma_nah_all_podoh,suma_ndfv,minzar10);
      zar_pr_ins(strsql);

      

      sprintf(strsql,"%s-Cумма зарплаты %.2f без неденежных форм выплаты %.2f меньше 10 минимальных зарплат %.2f\n",__FUNCTION__,tnsum.suma_nah_all_podoh,suma_ndfv,minzar10);
      zar_pr_ins(strsql);

      suma17_ndfv=suma_for_srav-minzar10;

      sprintf(strsql,"%s-%.2f процентов берётся с суммы %.2f+%.2f=%.2f\n",__FUNCTION__,proc2,suma_for_srav,minzar10,suma17_ndfv);
      zar_pr_ins(strsql);
      
      suma15_ndfv=suma_ndfv-suma17_ndfv;
      
      sprintf(strsql,"%s-%.2f процентов берётся с суммы %.2f+%.2f=%.2f\n",__FUNCTION__,proc1,suma_ndfv,suma17_ndfv,suma15_ndfv);
      zar_pr_ins(strsql);
      
     }
    else
     {
      sprintf(strsql,"%s-Cумма зарплаты %.2f без неденежных форм выплаты %.2f больше 10 минимальных зарплат %.2f\n",__FUNCTION__,tnsum.suma_nah_all_podoh,suma_ndfv,minzar10);
      zar_pr_ins(strsql);
      sprintf(strsql,"%s-Со всей суммы форм неденежной выплаты берётся налог в размере %.2f процентов\n",__FUNCTION__,proc2);
      zar_pr_ins(strsql);
      suma17_ndfv=suma_ndfv;

     }
     


   }

  
  /*единый социальный взнос отрицательный поэтому прибавляем*/
  double suma_for_pod=tnsum.suma_nah_all_podoh+suma_esv;
  sprintf(strsql,"%s-Сумма с которой вычисляем подоходный %.2f %.2f=%.2f\n",__FUNCTION__,tnsum.suma_nah_all_podoh,suma_esv,suma_for_pod);

  zar_pr_ins(strsql);
  
  
  double suma_for_pod15=minzar10;

  sprintf(strsql,"%s-Сумма для расчёта %.2f процентов равна 10 минимальным зарплатам %.2f\n",__FUNCTION__,proc1,minzar10);
  zar_pr_ins(strsql);

  if(fabs(suma15_ndfv) > 0.)
   {
    rudnfv(&suma_for_pod15,suma15_ndfv,proc1);
   }
    
  
  double podoh15=suma_for_pod15*proc1/100.;
  sprintf(strsql,"%s-Сумма подоходного до 10 минимальных зарплат %.2f*%f/100=%.2f\n",__FUNCTION__,suma_for_pod15,proc1,podoh15);    

  zar_pr_ins(strsql);


  double suma_for_pod17=suma_for_pod-minzar10;
  sprintf(strsql,"%s-Сумма для расчёта %.2f процентов равна %.2f-%.2f=%.2f\n",__FUNCTION__,proc2,suma_for_pod,minzar10,suma_for_pod17);
  zar_pr_ins(strsql);

  if(fabs(suma17_ndfv) > 0.)
   {

    rudnfv(&suma_for_pod17,suma17_ndfv,proc2);
   }

  double podoh17=suma_for_pod17*proc2/100.;
  sprintf(strsql,"%s-Сумма подоходного свыше 10 минимальных зарплат %.2f*%f/100=%.2f\n",__FUNCTION__,suma_for_pod17,proc2,podoh17);

  zar_pr_ins(strsql);

  suma_nal=podoh15+podoh17;
 
  sprintf(strsql,"%s-Сумма налога %.2f+%.2f=%.2f\n",__FUNCTION__,podoh15,podoh17,suma_nal);

  zar_pr_ins(strsql);


 }
suma_nal*=-1;  
return(suma_nal);

}
