/*$Id: podohrs3.c,v 5.2 2013-01-15 10:17:56 sasa Exp $*/
/*29.12.2015	15.12.2003	Белых А.И.	podohrs3.c
Расчёт подоходного налога в соответствии с новым законом вступающим в силу с 1.1.2004г.
Возвращяем величину подоходного налога
После 1.1.2011
для перерасчёта
*/
#include <math.h>
#include        "buhg.h"
//#include "zar_sumtn.h"

double podohrs3_pr1(short mes,short god,int tabnom,float proc1,float proc2,double minzar_ng,float max_sum_for_soc,class zar_sumtn *tnsum);


extern double   okrg;
extern float  kof_prog_min; //Коэффициент прожиточного минимума
extern float  ppn; //Процент подоходного налога
extern float  pomzp; //Процент от минимальной заработной платы


double podohrs3(int tabn,
short mr,short gr,
class zar_sumtn *tnsum,
int metka_zap, /*0-делать запись 1-нет*/
int metka_zap_lgot) /*0-устанавливать/снимать льготу 1-нет*/
{
char strsql[1024];
char stroka[1024];
float procent=0.;
float pr_b10mz=17.; /* Процент который берётся если сумма больше 10 минимальных зарплат*/
if(sravmydat(1,mr,gr,1,1,2015) >= 0)
 pr_b10mz=20.;
 
double nalog=0.;
double  maxsum=0.;
short du=0,mu=0,gu=0;
class zar_read_tn1h nast_mz;
SQLCURSOR cur;
SQL_str   row;


//читаем дату увольнения
sprintf(stroka,"select datk from Zarn where tabn=%d and god=%d and mes=%d",tabn,gr,mr);
if(sql_readkey(&bd,stroka,&row,&cur) == 1)
 rsdat(&du,&mu,&gu,row[0],2);

zar_read_tn1(1,mr,gr,&nast_mz);
  
maxsum=nast_mz.prog_min_ng*kof_prog_min;


sprintf(strsql,"\n%s\nМинимальная зарплата на начало года=%.2f\n",__FUNCTION__,nast_mz.minzar_ng);
zar_pr_ins(strsql);
sprintf(strsql,"Прожиточный минимум на начало года=%.2f\n",nast_mz.prog_min_ng);
zar_pr_ins(strsql);
sprintf(strsql,"Коэффициент прожиточного минимума=%.2f\n",kof_prog_min);
zar_pr_ins(strsql);
sprintf(strsql,"Процент подоходного налога=%.2f\n",ppn);
zar_pr_ins(strsql);
sprintf(strsql,"Процент от минимальной зарплаты=%.2f\n",pomzp);
zar_pr_ins(strsql);
sprintf(strsql,"Сумма на которую не распростаняется социальная льгота=%.2f\n",tnsum->suma_blg);
zar_pr_ins(strsql);
sprintf(strsql,"Сумма на которую распростаняется социальная льгота=%.2f\n",tnsum->suma_slg);
zar_pr_ins(strsql);
sprintf(strsql,"Сумма социальных отчислений=%.2f\n",tnsum->suma_esv_s_zarslg);
zar_pr_ins(strsql);
sprintf(strsql,"Сумма неденежных форм выплаты на которую распространяестя социальная льгота=%.2f\n",tnsum->suma_ndfv_slg);
zar_pr_ins(strsql);
sprintf(strsql,"Дата расчёта зарплаты %d.%d\n",mr,gr);
zar_pr_ins(strsql);
sprintf(strsql,"Дата увольнения %d.%d.%d\n",du,mu,gu);
zar_pr_ins(strsql);
sprintf(strsql,"Максимальный доход для льгот:%.2f*%.2f = %.2f\n",nast_mz.prog_min_ng,kof_prog_min,maxsum);
zar_pr_ins(strsql);

maxsum=okrug(maxsum,10.);

sprintf(strsql,"%s-Округлили %.2f\n",__FUNCTION__,maxsum);
zar_pr_ins(strsql);


sprintf(strsql,"%s-Сумма без соц-отчислений=%.2f %.2f=%.2f\n",__FUNCTION__,tnsum->suma_slg,tnsum->suma_esv_s_zarslg,tnsum->suma_slg+tnsum->suma_esv_s_zarslg);
zar_pr_ins(strsql);


int kollgot=0;
class iceb_tu_str kod_lgot("");
procent=zarlgot(tabn,mr,gr,&kollgot,&kod_lgot);


sprintf(strsql,"%s-Количество социальных льгот=%d\n",__FUNCTION__,kollgot);
zar_pr_ins(strsql);

sprintf(strsql,"%s-Максимальная сумма для которой применяется льгота %.2f*%d=%.2f\n",
__FUNCTION__,maxsum,kollgot,maxsum*kollgot);
zar_pr_ins(strsql);

maxsum*=kollgot;




if(procent == 0. || maxsum < tnsum->suma_slg+tnsum->suma_blg)
 {
  /*Льгота не применялась*/
  if(metka_zap == 0 && metka_zap_lgot == 0)
   {
    sprintf(stroka,"update Zarn set lgot='' where tabn=%d and god=%d and mes=%d",tabn,gr,mr);
    sql_zapis(stroka,1,0);
   }
  if(procent == 0.)
   {
    sprintf(strsql,"%s-Не имеет льгот!\n%s\n",__FUNCTION__,stroka);
    zar_pr_ins(strsql);
   }
  else
    if( maxsum < tnsum->suma_slg+tnsum->suma_blg)
     {
      sprintf(strsql,"%s-Льгота не применяется так как %.2f+%.2f > %.2f\n",__FUNCTION__,tnsum->suma_slg,tnsum->suma_blg,maxsum);
      zar_pr_ins(strsql);
     }
    
 }
else
 {
  if( maxsum >= tnsum->suma_slg+tnsum->suma_blg)
   {
    sprintf(strsql,"%s-Льгота применяется так как %.2f+%.2f <= %.2f\n",__FUNCTION__,tnsum->suma_slg,tnsum->suma_blg,maxsum);
    zar_pr_ins(strsql);
   }

  if(metka_zap == 0 && metka_zap_lgot == 0)
   {
    sprintf(stroka,"update Zarn set lgot='%s' where tabn=%d and god=%d and mes=%d",kod_lgot.ravno(),tabn,gr,mr);
    sql_zapis(stroka,1,0);
   }

  tnsum->suma_lgot=nast_mz.minzar_ng*(procent/100)*(pomzp/100);
  
  sprintf(strsql,"%s-Расчётная сумма льготы=%.2f*%.2f/100*%.2f/100=%.2f\n",__FUNCTION__,nast_mz.minzar_ng,procent,pomzp,tnsum->suma_lgot);
  zar_pr_ins(strsql);
 }



nalog=podohrs3_pr1(mr,gr,tabn,ppn,pr_b10mz,nast_mz.minzar_ng,nast_mz.max_sum_for_soc,tnsum);

if(nalog != 0.)
  nalog=okrug(nalog,okrg);

return(nalog);

}
/***********************************/
/**********************************************************/

double podohrs3_pr1(short mes,short god,
int tabnom,
float proc1,
float proc2,
double minzar_ng,
float max_sum_for_soc,
class zar_sumtn *tnsum)
{
char strsql[2048];
double minzar10=minzar_ng*10.;
double suma_nal=0.;


sprintf(strsql,"%s-Рассчитываем налог\n",__FUNCTION__);
zar_pr_ins(strsql);

sprintf(strsql,"%s-Десять минимальных зарплат %.2f*10=%.2f\n",__FUNCTION__,minzar_ng,minzar10);
zar_pr_ins(strsql);

double suma_for_srav=tnsum->suma_nah_all_podoh+tnsum->suma_esv_all;

sprintf(strsql,"%s-Сумма для сравнения %.2f+%.2f=%.2f\n",
__FUNCTION__,tnsum->suma_nah_all_podoh,tnsum->suma_esv_all,suma_for_srav);

zar_pr_ins(strsql);
double suma_ndfv=tnsum->suma_ndfv_slg+tnsum->suma_ndfv_blg;

if(suma_for_srav <= minzar10)
 {
  if(tnsum->suma_ndfv_slg != 0.)
    rudnfv(&tnsum->suma_slg,tnsum->suma_ndfv_slg,proc1);

  if(tnsum->suma_ndfv_blg != 0.)
    rudnfv(&tnsum->suma_blg,tnsum->suma_ndfv_blg,proc1);

  double suma_slg=tnsum->suma_slg; /*сумма для которой применяется соц.льгота*/
  double suma_blg=tnsum->suma_blg; /*сумма для которой не применяется льгота*/
  double suma_esv=0.; /*сумма единого соц.взноса с зарплаты для которой приеняется соц.льгота*/
  double suma_lgot=0.; /*cумма льгот*/

  if(suma_slg != 0. && tnsum->suma_slg+tnsum->suma_esv_s_zarslg >= tnsum->suma_lgot)
   {  
    suma_lgot=tnsum->suma_lgot;
    suma_esv=tnsum->suma_esv_s_zarslg;
   }    
  else
   {
    sprintf(strsql,"%s-Cумма для расчёта %.2f меньше льготы %.2f\n",__FUNCTION__,tnsum->suma_slg+tnsum->suma_esv_s_zarslg,tnsum->suma_lgot);
    zar_pr_ins(strsql);
    suma_slg=0.;
   }

  suma_nal=(suma_slg+suma_esv-suma_lgot)*proc1/100.+suma_blg*proc1/100.;

  sprintf(strsql,"%s-Cумма %.2f меньше десяти минимальных зарплат %.2f подоходный налог %f процентов\n",__FUNCTION__,suma_for_srav,minzar10,proc1);
  zar_pr_ins(strsql);

  sprintf(strsql,"%s-Подоходный налог:(%.2f+%.2f-%.2f)*%.2f/100.+%.2f*%.2f/100.=%.2f\n",
  __FUNCTION__,suma_slg,suma_esv,suma_lgot,proc1,suma_blg,proc1,suma_nal);
  zar_pr_ins(strsql);
 }
else
 {
/*Перед расчётом отнимает единый социальный взнос и с остатка берём подоходный*/
  sprintf(strsql,"%s-Cумма %.2f больше десяти минимальных зарплат %.2f\n",__FUNCTION__,suma_for_srav,minzar10);
  zar_pr_ins(strsql);

  suma_ndfv=tnsum->suma_ndfv_slg+tnsum->suma_ndfv_blg;

  sprintf(strsql,"tnsum.suma_ndfv_slg=%f tnsum.suma_ndfv_blg=%f\n",tnsum->suma_ndfv_slg,tnsum->suma_ndfv_blg);
  zar_pr_ins(strsql);

  
  double suma15_ndfv=0.;
  double suma17_ndfv=0.;
  if(suma_ndfv != 0.)
   {
    sprintf(strsql,"%s-Cумма неденежных форм выплаты %.2f\n",__FUNCTION__,suma_ndfv);
    zar_pr_ins(strsql);
    if(tnsum->suma_nah_all_podoh-suma_ndfv < minzar10)
     {
      
      sprintf(strsql,"%s-Cумма зарплаты %.2f без неденежных форм выплаты %.2f меньше 10 минимальных зарплат %.2f\n",__FUNCTION__,tnsum->suma_nah_all_podoh,suma_ndfv,minzar10);
      zar_pr_ins(strsql);

      

      sprintf(strsql,"%s-Cумма зарплаты %.2f без неденежных форм выплаты %.2f меньше 10 минимальных зарплат %.2f\n",__FUNCTION__,tnsum->suma_nah_all_podoh,suma_ndfv,minzar10);
      zar_pr_ins(strsql);

      suma17_ndfv=suma_for_srav-minzar10;

      sprintf(strsql,"%s-%.2f процентов берётся с суммы %.2f+%.2f=%.2f\n",__FUNCTION__,proc2,suma_for_srav,minzar10,suma17_ndfv);
      zar_pr_ins(strsql);
      
      suma15_ndfv=suma_ndfv-suma17_ndfv;
      
      sprintf(strsql,"%s-%.2f процентов берётся с суммы %.2f+%.2f=%.2f\n",__FUNCTION__,proc1,suma_ndfv,suma17_ndfv,suma15_ndfv);
      zar_pr_ins(strsql);
      
     }
    else
     {
      sprintf(strsql,"%s-Cумма зарплаты %.2f без неденежных форм выплаты %.2f больше 10 минимальных зарплат %.2f\n",__FUNCTION__,tnsum->suma_nah_all_podoh,suma_ndfv,minzar10);
      zar_pr_ins(strsql);
      sprintf(strsql,"%s-Со всей суммы форм неденежной выплаты берётся налог в размере %.2f процентов\n",__FUNCTION__,proc2);
      zar_pr_ins(strsql);
      suma17_ndfv=suma_ndfv;

     }
     


   }

  
  /*единый социальный взнос отрицательный поэтому прибавляем*/
  double suma_for_pod=tnsum->suma_nah_all_podoh+tnsum->suma_esv_all;
  sprintf(strsql,"%s-Сумма с которой вычисляем подоходный %.2f %.2f=%.2f\n",__FUNCTION__,tnsum->suma_nah_all_podoh,tnsum->suma_esv_all,suma_for_pod);

  zar_pr_ins(strsql);
  
  
  double suma_for_pod15=minzar10;

  sprintf(strsql,"%s-Сумма для расчёта %.2f процентов равна 10 минимальным зарплатам %.2f\n",__FUNCTION__,proc1,minzar10);
  zar_pr_ins(strsql);

  if(fabs(suma15_ndfv) > 0.)
   {
    rudnfv(&suma_for_pod15,suma15_ndfv,proc1);
   }
    
  
  double podoh15=suma_for_pod15*proc1/100.;
  sprintf(strsql,"%s-Сумма подоходного до 10 минимальных зарплат %.2f*%f/100=%.2f\n",__FUNCTION__,suma_for_pod15,proc1,podoh15);    

  zar_pr_ins(strsql);


  double suma_for_pod17=suma_for_pod-minzar10;
  sprintf(strsql,"%s-Сумма для расчёта %.2f процентов равна %.2f-%.2f=%.2f\n",__FUNCTION__,proc2,suma_for_pod,minzar10,suma_for_pod17);
  zar_pr_ins(strsql);

  if(fabs(suma17_ndfv) > 0.)
   {

    rudnfv(&suma_for_pod17,suma17_ndfv,proc2);
   }

  double podoh17=suma_for_pod17*proc2/100.;
  sprintf(strsql,"%s-Сумма подоходного свыше 10 минимальных зарплат %.2f*%f/100=%.2f\n",__FUNCTION__,suma_for_pod17,proc2,podoh17);

  zar_pr_ins(strsql);

  suma_nal=podoh15+podoh17;
 
  sprintf(strsql,"%s-Сумма налога %.2f+%.2f=%.2f\n",__FUNCTION__,podoh15,podoh17,suma_nal);

  zar_pr_ins(strsql);


 }
suma_nal*=-1;  
return(suma_nal);

}
