/*$Id: zaresv.c,v 5.22 2014/01/31 12:11:34 sasa Exp $*/
/*20.04.2016 	15.01.2011	Белых А.И.	zaresv.c
Расчёт удержания единого социального взноса с человека
Расчитывается сумма ЕСВ со всех начислений 
и сумма ЕСВ с начислений для которых применяется социальная льгота.
При расчёте подоходного налога отнимается сумма ЕСВ которая расчитана только с зарплаты
*/
#include <math.h>
#include "buhg.h"

 

extern char *shetb; /*Бюджетные счета*/
extern int kod_esv; /*Код удержания единого социального взноса*/
extern int kod_esv_bol; /*Код удержания единого социального взноса*/
extern int kod_esv_bol_inv; /*Код удержания единого социального взноса*/
extern int kod_esv_inv; /*Код удержания единого социального взноса*/
extern int kod_esv_dog; /*Код удержания единого социального взноса*/
extern int kod_esv_vs;  /*Для военнослужащих*/
extern class iceb_tu_str kods_esv_all;  /*Все коды удержания единого социального взноса*/

extern class iceb_tu_str knvr_esv_r; /*Коды не входящие в расчёт единого социального взноса с работника*/
extern class iceb_tu_str kod_zv_gr; /*коды званий гражданских*/
extern  short   *kodbl; /*Код больничного*/
extern class iceb_tu_str kod_dop_nah_bol; /*коды начилений дополнительно входящие в расчёт удержания ЕСВ с больничного*/
extern short    *kn_bsl; //Коды начислений на которые не распространяется льгота по подоходному налогу

double  zaresv(int tabn,short mp,short gp,int podr,
double *esv_s_lgot,
double *esv_s_lgotb,
int metka_zap, /*0-делать запись 1-нет*/
double suma_boln_for_per, /*используется только для перерасчёта подоходного налога из-за больничного*/
const char *uder_only)
{
class zaresv_rk resv;
char strsql[1024];
SQL_str row;
SQLCURSOR cur;
double suma=0.;
int kolstr=0;
int knah=0;

if(sravmydat(1,1,2016,1,mp,gp) <= 0)
 return(0.);
 
resv.mp=mp;
resv.gp=gp;
resv.tabn=tabn;
resv.podr=podr;
resv.metka_zap=metka_zap;
resv.suma_boln_for_per=suma_boln_for_per;  /*Сумма больничных для перерасчёта подоходного налога - обычно ноль*/

sprintf(strsql,"\n%s-Расчёт единого социального взноса\n\
------------------------------------------------------------\n",__FUNCTION__);
zar_pr_ins(strsql);

int kol_kod_esv=pole2(kods_esv_all.ravno(),',');
if(kol_kod_esv == 0)
 {
  sprintf(strsql,"\n%s-Не введены коды единого социального взноса в файле настройки!\n",__FUNCTION__);
  zar_pr_ins(strsql);
  return(0.);
  
 }
int nomer=0;
for(nomer=0; nomer < kol_kod_esv; nomer++)
 {
  int kod=0;
  polen(kods_esv_all.ravno(),&kod,nomer+1,',');
  
  /*Проверяем есть ли код удержания взноса*/
  sprintf(strsql,"select shet from Zarn1 where tabn=%d and prn='2' and knah=%d",tabn,kod);

  if(readkey(strsql,&row,&cur) > 0)
    break;
 }

if(nomer == kol_kod_esv) /*на Форте записи в таблицу Zarn1 не делають*/
  for(nomer=0; nomer < kol_kod_esv; nomer++)
   {
    int kod=0;
    polen(kods_esv_all.ravno(),&kod,nomer+1,',');
    sprintf(strsql,"select shet from Zarp where datz >= '%04d-%02d-%02d' and datz <= '%04d-%02d-%02d' \
and tabn=%d and prn='2' and knah=%d limit 1",gp,mp,1,gp,mp,31,tabn,kod);
    if(readkey(strsql,&row,&cur) > 0)
     break;
   }

if(nomer == kol_kod_esv)
 {
  sprintf(strsql,"\n%s-Не введён код единого социального взноса в список удержаний с работника!\n",__FUNCTION__);
  zar_pr_ins(strsql);
  return(0.);
 }
resv.shet.new_plus(row[0]);

if(resv.shet.getdlinna() <= 1)
 {
  sprintf(strsql,"%s-Не введён счёт в удержании единого социального взноса !!!\n",__FUNCTION__);
  zar_pr_ins(strsql);
  return(0.);
 }
if(proverka(uder_only,kod_esv,0,0) != 0)
 {
  sprintf(strsql,"%s-Код %d исключён из расчёта\n",__FUNCTION__,kod_esv);
  zar_pr_ins(strsql);
  return(0.); 
 }


/*Смотрим начисления*/
short mesn=0;
short godn=0;
sprintf(strsql,"select knah,suma,shet,mesn,godn from Zarp where datz >= '%04d-%02d-%02d' \
and datz <= '%04d-%02d-%02d' and tabn=%d and prn='1' and suma <> 0.",gp,mp,1,gp,mp,31,tabn);
if((kolstr=cur.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return(0);
 }

while(cur.read_cursor(&row) != 0)
 {
  if(proverka(knvr_esv_r.ravno(),row[0],0,1) == 0)
   continue;   
  sprintf(strsql,"%s-knah=%s suma=%s shet=%s mesn=%s\n",__FUNCTION__,row[0],row[1],row[2],row[3]);
  zar_pr_ins(strsql);

  knah=atoi(row[0]);
  suma=atof(row[1]);
  mesn=atoi(row[3]);
  godn=atoi(row[4]);

  if(provkod(kodbl,knah) >= 0 || proverka(kod_dop_nah_bol.ravno(),knah,0,1) == 0)
    resv.suma_bol_ob+=suma;
  else
   {
    resv.suma_ob+=suma;
    if(mesn == mp && godn == gp)
     resv.suma_v_mes_ras+=suma;
   }

  if(proverka(shetb,row[2],0,1) == 0)
   {
    if(provkod(kodbl,knah) >= 0 || proverka(kod_dop_nah_bol.ravno(),knah,0,1) == 0)
      resv.suma_bol_bud+=suma;
    else
      resv.suma_bud+=suma;
   }

  if(provkod(kn_bsl,knah) < 0)
   {
    if(provkod(kodbl,knah) >= 0)
     { 
      if(mesn == mp)
       resv.suma_s_lgot_bol+=suma;
     }
    else      
      resv.suma_s_lgot+=suma;

    if(proverka(shetb,row[2],0,1) == 0)
     {
      if(provkod(kodbl,knah) >= 0)
       {
        if(mesn == mp)
          resv.suma_s_lgotb_bol+=suma;
       }
      else
        resv.suma_s_lgotb+=suma;
     }
   }

 }


double voz=zaresv_rs(&resv);

*esv_s_lgot=resv.esv_s_lgot;
*esv_s_lgotb=resv.esv_s_lgotb;

return(voz);

}



/*************************************/
/***********************************/

void zaresv_ras(int tabn,short mp,short gp,double suma,float proc,double *suma_esv,double max_sum_for_soc,double suma_for_srav)
{
char strsql[1024];
if(suma_for_srav > max_sum_for_soc)
 {
  sprintf(strsql,"%s-Сумма %.2f > %.2f\nВ расчёт берём %.2f\n",__FUNCTION__,suma_for_srav,max_sum_for_soc,max_sum_for_soc);
  zar_pr_ins(strsql);
  suma=max_sum_for_soc;
 }
*suma_esv=0.;
if(suma > 0.)
 {
  *suma_esv=suma*proc/100.*-1;

  sprintf(strsql,"%s-Сумма единого социального взноса %.2f*%.2f/100.=%.2f\n",__FUNCTION__,suma,proc,*suma_esv);
  zar_pr_ins(strsql);
 }


}
/****************************************/
/*Расчёт*/
/***************************************/
double zaresv_rs(class zaresv_rk *resv)
{


int kod_esv_vr=kod_esv;
char bros[1024];
class ZARP     zp;
double suma_esv=0.;
double suma_esvb=0.;
double suma_esv_bol=0.;
double suma_esv_bol_bud=0.;
double suma_esv_ob=0.;
class iceb_tu_str shet(resv->shet.ravno());
class iceb_tu_str shet_bud("");
SQL_str row;
class SQLCURSOR cur;
char strsql[2048];
short d;
int kod_bol=kod_esv_bol;
float proc_bol=0.;
double proc_esv_prim=0.; /*Процент который был применён для расчёта */

class zar_read_tn1h nastr;
/*чтение настроек минимальной зарплаты и прожиточного минимума по дате*/
zar_read_tn1(1,resv->mp,resv->gp,&nastr);
/*Читаме проценты по расчётной дате*/
class zarrnesvp_rek esvp;
zarrnesvp(resv->mp,resv->gp,&esvp);

proc_esv_prim=esvp.proc_esv;

 
sprintf(strsql,"\
%s-Коды не входящие в расчёт-%s\n\
Проценты %f С больничного %f С инвалида %f С договоров %f С военных %f С больничного для инвалида %f\n",
__FUNCTION__,
knvr_esv_r.ravno(),
esvp.proc_esv,
esvp.proc_esv_bol,
esvp.proc_esv_inv,
esvp.proc_esv_dog,
esvp.proc_esv_vs,
esvp.proc_esv_bol_inv);

zar_pr_ins(strsql);

proc_bol=esvp.proc_esv_bol;

dpm(&d,&resv->mp,&resv->gp,5);

zp.dz=d;
zp.mesn=resv->mp; zp.godn=resv->gp;
zp.nomz=0;
zp.podr=resv->podr;

/*Читаем бюджетный счёт*/
sprintf(strsql,"select shetb from Uder where kod=%d",kod_esv_vr);
if(readkey(strsql,&row,&cur) == 1)
 shet_bud.new_plus(row[0]);

sprintf(strsql,"%s-Cумма общая %.2f\nСумма бюджетная %.2f Cумма больничных %.2f Сумма бюджетных больничных %.2f\nСумма в счёт месяца расчёта %.2f",
__FUNCTION__,resv->suma_ob,resv->suma_bud,resv->suma_bol_ob,resv->suma_bol_bud,resv->suma_v_mes_ras);
zar_pr_ins(strsql);

 
int metka_inv=zarprtn(resv->mp,resv->gp,resv->tabn,2); 
if(metka_inv == 1)
 {
  proc_bol=esvp.proc_esv_bol_inv;
  kod_bol=kod_esv_bol_inv;
  kod_esv_vr=kod_esv_inv;
  proc_esv_prim=esvp.proc_esv_inv;
  sprintf(strsql,"%s-Инвалид ставка %.2f\n",__FUNCTION__,proc_esv_prim);
  zar_pr_ins(strsql);

  /*Читаем счёт*/
  sprintf(strsql,"select shet,shetb from Uder where kod=%d",kod_esv_vr);
  if(readkey(strsql,&row,&cur) == 1)
   {
    shet.new_plus(row[0]);
    shet_bud.new_plus(row[1]);
   }
 }

int metka_dog=zarprtn(resv->mp,resv->gp,resv->tabn,3); 
if(metka_dog == 1)
 {
  kod_esv_vr=kod_esv_dog;
  proc_esv_prim=esvp.proc_esv_dog;
  sprintf(strsql,"%s-Работает по договору ставка %.2f\n",__FUNCTION__,proc_esv_prim);
  zar_pr_ins(strsql);
  /*Читаем счёт*/
  sprintf(strsql,"select shet,shetb from Uder where kod=%d",kod_esv_vr);
  if(readkey(strsql,&row,&cur) == 1)
   {
    shet.new_plus(row[0]);
    shet_bud.new_plus(row[1]);
   }
 }

sprintf(strsql,"select zvan from Zarn where tabn=%d and god=%d and mes=%d",resv->tabn,resv->gp,resv->mp);
if(readkey(strsql,&row,&cur) == 1)
if(atoi(row[0]) != 0)
 if(proverka(kod_zv_gr.ravno(),row[0],0,0) != 0)
  {

   sprintf(strsql,"%s-Военный %s != %s\n",__FUNCTION__,kod_zv_gr.ravno(),row[0]);
   zar_pr_ins(strsql);
   if(kod_esv_vs == 0)
    {
     sprintf(strsql,"%s-Код удержания единого социального взноса для военных равен нолю!\n",__FUNCTION__);
     zar_pr_ins(strsql);
     return(0.); 
    }
   kod_esv_vr=kod_esv_vs;
   proc_esv_prim=esvp.proc_esv_vs;
   /*Читаем счёт*/
   sprintf(strsql,"select shet,shetb from Uder where kod=%d",kod_esv_vr);
   if(readkey(strsql,&row,&cur) == 1)
    {
     shet.new_plus(row[0]);
     shet_bud.new_plus(row[1]);
    }
   if(shet.getdlinna() <= 1)
    {
     sprintf(strsql,"%s-Не введён счёт для удержания %d !!!!\n",__FUNCTION__,kod_esv_vr);
     zar_pr_ins(strsql);
     return(0.);
    }
  }

class iceb_tu_str shet_bol("");
class iceb_tu_str shet_bolb("");
/*Читаем счёт*/
sprintf(strsql,"select shet,shetb from Uder where kod=%d",kod_bol);
if(readkey(strsql,&row,&cur) == 1)
 {
  shet_bol.new_plus(row[0]);
  shet_bolb.new_plus(row[1]);
 }

if(shet_bol.getdlinna() <= 1)
 {
  sprintf(strsql,"%s-Не введён счёт для удержания %d !!!!\n",__FUNCTION__,kod_bol);
  zar_pr_ins(strsql);
  return(0.);
 }
 
sprintf(strsql,"%s-Только с суммы на которую распространяется льгота\n",__FUNCTION__);
zar_pr_ins(strsql);

double bb1=0.,bb2=0.;
zaresv_ras(resv->tabn,resv->mp,resv->gp,resv->suma_s_lgot,proc_esv_prim,&bb1,nastr.max_sum_for_soc,resv->suma_s_lgot);


if(resv->suma_boln_for_per != 0.)
 {
  sprintf(strsql,"%s-Увеличиваем сумму больничного на которую распространяется льгота %.2f+%.2f=%.2f\n",__FUNCTION__,resv->suma_s_lgot_bol,resv->suma_boln_for_per,resv->suma_s_lgot_bol+resv->suma_boln_for_per);
  zar_pr_ins(strsql);
  resv->suma_s_lgot_bol+=resv->suma_boln_for_per;
 }

zaresv_ras(resv->tabn,resv->mp,resv->gp,resv->suma_s_lgot_bol,proc_bol,&bb2,nastr.max_sum_for_soc,resv->suma_s_lgot_bol);

resv->esv_s_lgot=bb1+bb2;
sprintf(strsql,"%s-%.2f+%.2f=%.2f\n",__FUNCTION__,bb1,bb2,resv->esv_s_lgot);
zar_pr_ins(strsql);

sprintf(strsql,"%s-C cуммы не больничных\n",__FUNCTION__);
zar_pr_ins(strsql);
zaresv_ras(resv->tabn,resv->mp,resv->gp,resv->suma_ob,proc_esv_prim,&suma_esv,nastr.max_sum_for_soc,resv->suma_v_mes_ras);

if(resv->suma_boln_for_per != 0.)
 {
  sprintf(strsql,"%s-Увеличиваем сумму больничного общего %.2f+%.2f=%.2f\n",__FUNCTION__,resv->suma_bol_ob,resv->suma_boln_for_per,resv->suma_bol_ob+resv->suma_boln_for_per);
  zar_pr_ins(strsql);
  resv->suma_bol_ob+=resv->suma_boln_for_per;
 }

if(resv->suma_bol_ob != 0.)
 {
  sprintf(strsql,"%s-C больничного\n",__FUNCTION__);
  zar_pr_ins(strsql);
  zaresv_ras(resv->tabn,resv->mp,resv->gp,resv->suma_bol_ob,proc_bol,&suma_esv_bol,nastr.max_sum_for_soc,resv->suma_bol_ob);

 }
if(resv->suma_bol_bud != 0.)
 {
  sprintf(strsql,"%s-C бюджетного больничного\n",__FUNCTION__);
  zar_pr_ins(strsql);
  zaresv_ras(resv->tabn,resv->mp,resv->gp,resv->suma_bol_bud,proc_bol,&suma_esv_bol_bud,nastr.max_sum_for_soc,resv->suma_bol_bud);

 }

suma_esv_ob=suma_esv+suma_esv_bol;

sprintf(strsql,"%s-Общая сумма=%.2f+%.2f=%.2f\n",__FUNCTION__,suma_esv,suma_esv_bol,suma_esv_ob);
zar_pr_ins(strsql);

if(shetb == NULL || shet_bud.getdlinna() <= 1)
 {
  
  
  if(resv->metka_zap == 0)
   {
    strcpy(zp.shet,shet.ravno());

    sprintf(strsql,"%s-1пишем код %d\n",__FUNCTION__,kod_esv_vr);
    zar_pr_ins(strsql);

    sprintf(bros,"ЄСВ-%.2f%%",proc_esv_prim);
    zapzarp(d,resv->mp,resv->gp,resv->tabn,2,kod_esv_vr,suma_esv,shet.ravno(),resv->mp,resv->gp,0,0,bros,resv->podr,"",zp);

    sprintf(strsql,"%s-2пишем код %d\n",__FUNCTION__,kod_bol);
    zar_pr_ins(strsql);
    strcpy(zp.shet,shet_bol.ravno());
  
    sprintf(bros,"ЄСВ-%.2f%%",proc_bol);
    zapzarp(d,resv->mp,resv->gp,resv->tabn,2,kod_bol,suma_esv_bol,shet_bol.ravno(),resv->mp,resv->gp,0,0,bros,resv->podr,"",zp);
   }
 }
else
 {
  /*Бюджетный больничный*/
  if(shet_bolb.getdlinna() > 1)
   {
    sprintf(strsql,"%s-3 пишем код %d %.2f %d.%d\n",__FUNCTION__,kod_bol,suma_esv_bol_bud,resv->mp,resv->gp);
    zar_pr_ins(strsql);

    strcpy(zp.shet,shet_bolb.ravno());

    if(resv->metka_zap == 0 )
     {
      sprintf(bros,"ЄСВ-%.2f%%",proc_bol);
      zapzarp(d,resv->mp,resv->gp,resv->tabn,2,kod_bol,suma_esv_bol_bud,shet_bolb.ravno(),resv->mp,resv->gp,0,0,bros,resv->podr,"",zp,NULL);
     }
   } 
  /*Хозрасчётный больничный*/
  sprintf(strsql,"4 пишем код %d %.2f %s\n",kod_bol,suma_esv_bol-suma_esv_bol_bud,shet_bol.ravno());
  zar_pr_ins(strsql);

  strcpy(zp.shet,shet_bol.ravno());

 if(resv->metka_zap == 0 )
   {
    sprintf(bros,"ЄСВ-%.2f%%",proc_bol);
    zapzarp(d,resv->mp,resv->gp,resv->tabn,2,kod_bol,suma_esv_bol-suma_esv_bol_bud,shet_bol.ravno(),resv->mp,resv->gp,0,0,bros,resv->podr,"",zp,NULL);
   }
  /*Общюю сумму мы уже знаем.Делаем расчёт для бюджета и отнимаем от общей суммы*/
  sprintf(strsql,"%s-Делаем расчёт для бюджета\n",__FUNCTION__);
  zar_pr_ins(strsql);

  sprintf(strsql,"%s-Только зарплата\n",__FUNCTION__);
  zar_pr_ins(strsql);
  
  zaresv_ras(resv->tabn,resv->mp,resv->gp,resv->suma_s_lgotb,proc_esv_prim,&resv->esv_s_lgotb,nastr.max_sum_for_soc,resv->suma_s_lgotb);
  
  sprintf(strsql,"%s-Cо всей суммы\n",__FUNCTION__);
  zar_pr_ins(strsql);

  zaresv_ras(resv->tabn,resv->mp,resv->gp,resv->suma_bud,proc_esv_prim,&suma_esvb,nastr.max_sum_for_soc,resv->suma_bud);
  
  
  double suma_zap=suma_esvb;

  sprintf(strsql,"%s-Бюджетная сумма=%.2f\n",__FUNCTION__,suma_zap);
  zar_pr_ins(strsql);

  if(shet.getdlinna() > 1)
   {
    if(resv->metka_zap == 0 )
     {
      sprintf(bros,"%s-ЄСВ-%.2f%%",gettext("Общий фонд"),proc_esv_prim);
      strcpy(zp.shet,shet_bud.ravno());
      zapzarp(d,resv->mp,resv->gp,resv->tabn,2,kod_esv_vr,suma_zap,shet_bud.ravno(),resv->mp,resv->gp,0,0,bros,resv->podr,"",zp,NULL);
     }
   }

  sprintf(strsql,"%s-Хозрасчётная сумма=%.2f-%.2f=%.2f\n",__FUNCTION__,suma_esv,suma_zap,suma_esv-suma_zap);
  zar_pr_ins(strsql);

  suma_zap=suma_esv-suma_zap;


  if(shet.getdlinna() > 1)
   {
    if(resv->metka_zap == 0 )
     {
      sprintf(bros,"%s-ЄСВ-%.2f%%",gettext("Специальный фонд"),proc_esv_prim);
      strcpy(zp.shet,shet.ravno());
      zapzarp(d,resv->mp,resv->gp,resv->tabn,2,kod_esv_vr,suma_zap,shet.ravno(),resv->mp,resv->gp,0,0,bros,resv->podr,"",zp,NULL);
     }
   }
 }
return(suma_esv_ob);
}
