/*$Id: iceb_t_nn6_end.c,v 5.6 2014/07/31 07:09:27 sasa Exp $*/
/*14.02.2015	26.01.2015	Белых А.И.	iceb_t_nn7_end.c
Распечатка концовки налоговой накладной 
*/

#include        <errno.h>
#include "buhl.h"

void iceb_t_nn7_end(int tipz, 
short lnds,
double itogo,
double sumkor,
const char *naimnal,
float procent, //Процент налога на рекламные услуги
float pnds,
const char *imaf_nastr,
const char *kodop,
double okrg1, /*Округление*/
double suma_voz_tar,
const char *kod_kontr,
FILE *ff)
{
class iceb_tu_str stroka("");
int nomer_st=0;
class SQLCURSOR cur_alx;
SQL_str row_alx;
int kolstr=0;
char strsql[512];
class iceb_tu_str fio("");

sprintf(strsql,"select str from Alx where fil='nn7_end.alx' order by ns asc");
if((kolstr=cur_alx.make_cursor(&bd,strsql)) < 0)
 {
  msql_error(&bd,gettext("Ошибка создания курсора !"),strsql);
  return;
 }

if(kolstr == 0)
 {
  sprintf(strsql,"%s %s!",gettext("Не найдена настройка"),"nn7_end.alx");
  iceb_t_soob(strsql);
  return;
 }


fprintf(ff,"ICEB_LST_END\n");
char bros[512];
//пропускаем одну строку

double sumanr=0.;
if(procent != 0)
 {
  sumanr=itogo*procent/100.;
  sumanr=okrug(sumanr,okrg1);
 }
sumanr+=suma_voz_tar;

double bb1=0.;

while(cur_alx.read_cursor(&row_alx) != 0)
 {
  if(row_alx[0][0] == '#')
     continue;
  nomer_st++;
  stroka.new_plus(row_alx[0]);
  switch (nomer_st)
   {  

    case 2:
      //Всього по розділу І

      sprintf(bros,"%10s",prcn(itogo));

      if(lnds == 0 )
        iceb_tu_vstav(&stroka,bros,103,113,1);

      if(lnds == 1 )
       {
        sprintf(bros,"%9s",prcn(itogo));
        iceb_tu_vstav(&stroka,bros,125,134,1);
       }
      if(lnds == 2)
       {
        sprintf(bros,"%9s",prcn(itogo));
        iceb_tu_vstav(&stroka,bros,135,144,1);
       }
      if(lnds == 3)
       {
        sprintf(bros,"%9s",prcn(itogo));
        iceb_tu_vstav(&stroka,bros,145,154,1);
       }
      if(lnds == 4 )
        iceb_tu_vstav(&stroka,bros,114,124,1);
      sprintf(bros,"%11s",prcn(itogo));
      iceb_tu_vstav(&stroka,bros,155,166,1);
      break;  


    case 4:
      /*Зворотна (заставна) тара*/


      if(sumanr != 0.) //Процент налога на рекламные услуги
       {

        sprintf(bros,"%11s",prcn(sumanr));
        iceb_tu_vstav(&stroka,bros,155,166,1);
        if(procent != 0.)
         {
          sprintf(bros,"%-*s",iceb_tu_kolbait(50,naimnal),naimnal); //чтобы наверняка забить текущий текст
          iceb_tu_vstav(&stroka,bros,8,55,1);
         }
       }
      
    
      break;



    case 6: /*Податок на додану вартість*/
      bb1=0.;
      if(lnds == 0) //20% НДС
       {
        bb1=(itogo+sumkor)*pnds/100.;
        bb1=okrug(bb1,okrg1);

        sprintf(bros,"%10s",prcn(bb1));
        iceb_tu_vstav(&stroka,bros,103,113,1);

        sprintf(bros,"%11s",prcn(bb1));
        iceb_tu_vstav(&stroka,bros,155,166,1);
       }

      if(lnds == 3) //Освобождение от НДС теперь это не надо тут выводить вывотится только винизу
       {

        iceb_tu_vstav(&stroka,"Без ПДВ",146,155,1);
       }

      if(lnds == 4) //7% НДС
       {
        bb1=(itogo+sumkor)*pnds/100.;
        bb1=okrug(bb1,okrg1);

        sprintf(bros,"%10s",prcn(bb1));
        iceb_tu_vstav(&stroka,bros,114,124,1);

        sprintf(bros,"%11s",prcn(bb1));
        iceb_tu_vstav(&stroka,bros,155,166,1);
       }


      break;
     


    case 8: /*Загальна сума з ПДВ*/
      sprintf(bros,"%10.2f",itogo+sumkor+bb1+sumanr);
      if(lnds == 0)
        iceb_tu_vstav(&stroka,bros,103,113,1);
      if(lnds == 1)
       {
        sprintf(bros,"%9.2f",itogo+sumkor+bb1+sumanr);
        iceb_tu_vstav(&stroka,bros,125,134,1);
       }
      if(lnds == 2)
       {
        sprintf(bros,"%9.2f",itogo+sumkor+bb1+sumanr);
        iceb_tu_vstav(&stroka,bros,135,144,1);
       }
      if(lnds == 3)
       {
        sprintf(bros,"%9.2f",itogo+sumkor+bb1+sumanr);
        iceb_tu_vstav(&stroka,bros,145,154,1);
       }
      if(lnds == 4)
       {
        sprintf(bros,"%10.2f",itogo+sumkor+bb1+sumanr);
        iceb_tu_vstav(&stroka,bros,114,124,1);
       }
      sprintf(bros,"%11.2f",itogo+sumkor+bb1+sumanr);
      iceb_tu_vstav(&stroka,bros,155,166,1);
      break;

    case 13: /*Фамилия исполнителя*/
      if(tipz == 1)
        break;
      fio.new_plus("");
      iceb_t_poldan("Исполнитель",&fio,"matnast.alx");
      if(fio.getdlinna() <= 1)
       {
        fio.new_plus(iceb_t_getfioop());
       }

      iceb_tu_vstav(&stroka,fio.ravno(),100,150,1);
      break;

    case 18: /*пункти налогового кодекса которыми пердусмотрено освобождение от НДС*/
      if(lnds == 3) //Освобождение от НДС
       {
        class iceb_tu_str punkt_zak(""); //Пункт закона на основании которого есть освобождение от НДС
        class iceb_tu_str naim_nast("Пункт закона освобождения от НДС для операции");
        naim_nast.plus(" ",kodop);

        iceb_t_poldan(naim_nast.ravno(),&punkt_zak,imaf_nastr);

        if(punkt_zak.ravno()[0] != '\0')
         {        

          iceb_tu_vstav(&stroka,punkt_zak.ravno(),3,139,1);
         }      
       } 
       break;
   }
 fprintf(ff,"%s",stroka.ravno());
}
fprintf(ff,"%s\n",kod_kontr);

if(iceb_t_poldan_vkl("Системная подпись в налоговой накладной","matnast.alx") == 0)
 {
  podpis(ff);
 }

fclose(ff);

}
